/*  2020.c   */
/*       by Ted Huntington   */
/*  This program runs the interactive graphic adventure.... */
/*  			2 0 2 0   !!!			    */

#include "stdio.h"
#include "stdlib.h"
#include "conio.h"
#include "process.h"
#include "math.h"
#include "time.h"
#include "alloc.h"
#include "string.h"
#include "graphics.h"
#include "fcntl.h"
#include "dos.h"
#include "ctype.h"
#include "2020.h"

/*structures*/
struct action         /*actions*/
   {
   int name;  /*0-color,1-brush,2-lstyle,3-point,*/
	      /*4-line,5-circle,6-rect,7-fill,8-text*/
   int a[5];   /*x1-color-brush,y1-style,x2-rad-direct-tsize,y2-strlen*/
   char str[SLEN];  /*string*/
   };
struct daction         /*dynamic actions*/
   {
   int name;
   int a[5];
   char str[SLEN];
   struct daction *next;
   };
struct daction *act1,*act2;   /*pic draw actions-begin link, temp link*/
struct daction *act3;   /*temp2 link*/
int cur,chrcur;   /*current act*/

struct doors		/*door structs*/
  {
  int a[4];	/*x1,y1,x2,y2*/
  int vis;	/*0-yes, 1-no*/
  int next;	/*next room*/
  };
struct doors door[NUMDOR];
struct objects
  {
  char name[LENOBJ];
  int p[4];
  int loc;
  };
struct objects obj[NUMOBJ];
struct objects mobj[NUMMOBJ];
struct date today;
struct time utime,mtime,dtime;
struct words
  {
  char nm[15];   /*15*/
  };
struct words cword[80];
struct words word[] = {"quit","look","save","restore","get","drop",
	"time","exit","start","shower","watch","turn","put","switch",
	"read","salt","pepper","inven","inventory","take","inv","open",
	"close","shut","push","scope","pull","press","enter","date",
	"shit","fuck","phone","smell","touch","listen","feel","taste",
	"eat","drink","smoke","hate","sleep","love","call","damn","change",
	"mean","think","hello","hi","good","bad","bye","goodbye","stop","go",
	"follow","lead","answer","piss","pee","fart","cum","come","search",
	"pick","scratch","toke","play","sit","talk","type","write",
	"dance","stand","walk","run","speed","slow","masterbate","jerk",
	"ejaculate","breathe","inject","say","speak","work","deliver","wash",
	"dry","live","die","kill","hurt","punch","kick","shoot","drive",
	"steer","direct","produce","develop","stab","cut","bang","do",
	"separate","connect","disconnect","hang","recognize","know","move",
	"kiss","slap","curse","screw","use","ask","make","help","hint",
	"insert","exchange","sell","commit","stay","unlock","lock","buy",
	"purchase","throw","toss","give","want","dial","compro","","","","","","","","","",
	"","","","","","","","","","","","","","","","","","","","","","",
	"","","","","","","","","","","","","","","","","","","","","","",
	"","","","","","","","","","","","the","a","an","un","","","","","",
	"","","","","","","","who","what","where","why","when","how","is",
	"are","am","have","yes","no","maybe","","","","","","","",
	"i","you","me","us","we","her","him","them","it","god","this","that","","","","",
	"all","any","away","into","over","front","back","left","right","on","around",
	"under","in","at","through","thru","out","off","backward","forward",
	"inside","outside","to","too","also","with","without","and","or",
	"up","down","of","above","behind","game","rug","statue",
	"fireplace","grate","wall","floor","telescope","love","city",
	"water","ocean","traffic","road","highway","bed","waterbed","desk",
	"card","link","refridge","car","cars","automobiles","fridge",
	"bedroom","kitchen","bathroom","room","bath","bathtub","tub",
	"toilet","mirror","towel","rack","sink","door","tv","television",
	"stereo","window","shade","curtain","blind","shades","curtains",
	"blinds","couch","couches","carpet","radio","music","drape",
	"drapes","doors","button","scope","inside","windows","date",
	"channel","station","channels","stations","change","statues",
	"fire","grill","walls","table","stove","oven","microwave",
	"cabinet","cabinets","telephone","drawer","microscope",
	"videophone","money","drawers","paper","papers","wing","wings",
	"plane","planes","airplanes","helicopter","helicopters","heli",
	"helis","life","cash","nature","science","sun","trash","garbage",
	"shaker","stock","stocks","certificate","certificates","can",
	"container","automobile","sidewalk","translator","refridgerator",
	"freezer","cupboard","message","underground","mom","package",
	"packages","box","boxes","mailbox","apartment","apartments",
	"human","person","man","woman","clerk","job","seed","spore",
	"mailboxes","seeds","spores","earth","moon","id","usa","disc",
	"discs","encyclopedia","galactica","history","planet","key","keys",
	"disk","disks","world","machine","ticket","mexico","canada","dollar",
	"dollars","body","suicide","robot","president","north","south",
	"east","west","blue","green","orange","red","sofa","elevator",
        "employment","elevators","cd","rom","drug","drug","mail",
	"together","apart","","","but","however","0","1","2","3","4","5",
	"6","7","8","9","religion","Huntington","Plank","atheism",
	"Jones","Smith","Collins","Dettor","marriage","photon","Sagan","carl",
	"tim","ferris","tom","161945695690","180055551212","120200000001",
	"911","Tracy","Ted","Theodore","nude","mendeleev","carver","anaxagarus","aristarchus",
	"Newton","Galileo","Edison","John","Lennon","JFK","RFK","truth",
	"brain","vagina","penis","anatomy","evolution",
	"politician","lawyer","doctor","thief","surgeon","fisher","fire",
	"cop","police","architect","writer","poet","musician",
	"engineer","teacher","student","self","construction"};

struct event
   {
   struct time beg;     /*begin time for event*/
   struct time end;	/*end time for event*/
   int loc;		/*location # of event*/
   int obnum;		/*object number that appears-disappears*/
   };
struct event eve[NUMEVE];

/*Globals*/
unsigned size;    	/*  size of bit image */
void *brushbuff;	/*  pointer to buffer*/
unsigned csize;    	/*  size of cursor bit image */
void *cbuff;	/*  pointer to cursor buffer*/
unsigned sizeman;	/*size of character image*/
unsigned sizeheli;
unsigned sizecar;
unsigned sizeroad;
unsigned sizespike;
unsigned sizeline;	/*size of line fills*/
void *man[8];		/*pointers to character image*/
void *robot[8];
void *screen[7+NUMMOBJ];           /*pointers to background for images*/
void *screen3[2];           /*pointers to background for images*/
void *heli[5];		/*pointers to heli images*/
void *car[NUMCAR];           /*pointers to car images*/
void *road[NUMROAD];
void *spike[NUMSPIKE];
void *lines3[17];        /*17 - robot background lines*/
void *lines[170];	/*170 background lines  17-char  48-heli */
char upat1[8] =  {0x18, 0x3c,0x7e,0xff,0xff,0x7e,0x3c,0x18};
char upat2[8] =  {0x00, 0xf7,0xf7,0xf7,0x00,0xfe,0xfe,0xfe};
char upat3[8] =  {0xee, 0xee,0xee,0xee,0xe0,0xee,0xee,0x0e};
char cursor[2] = {0xdb, 0x00};
char PATH[256];
char LPATH[] = {0x5c,'\0'};
char strtim[17];	/*string for time*/
char command[COMLEN];	/*string for user input*/
char it[300];		/*string for computer*/
char precom[COMLEN];	/*previous command*/
char des[DESC1][DESC2];	/*current location description*/
char name[30];
int lcolor,lc,oldcolor;	/*  line color */
int pattern,border,brush,redraw;/*  fill pattern  */
int onemo;		/* just erase extra*/
int p1,p2,midx,midy;			/*  1st point for circle or line*/
int lstyle,style,direction,tsize;    /*text descriptions*/
int ex,ex2;			/*exit flags*/
int radx,rady;		/*radii for ellipse*/
int x1,y1,x2,y2;        /*character coordinates*/
int x3,y3,x4,y4;       /*robot coords*/
int carx[NUMCAR];   /*car coord*/
int roadx[NUMROAD],spikex[NUMSPIKE];
int skin[8],skin3[8];
int numimg,numimg2,numimg3,numimg4;
int page;		/*current graphics page*/
int lflag;		/*load character flag*/
int pntx[4],pnty[4];	/*boundary points for picture*/
int hitflag;		/*boundary hit flag*/
int dx, dy;		/*change in x1 and y1*/
int dx2,dy2;
int mode;		/*character direct 0-dn 1-lt 2-up 4-rt*/
int mode3;
int curloc,curloc3;		/*location number you and robot*/
int curobj;		/*current object*/
int newloc;		/*new location number*/
int doorflag;		/*hit door*/
int speed;		/*speed of game action*/
int cursx,cursy,precur;	/*cursor coords*/
int numwd;              /*number of words in database*/
int wdflag;		/*how many words in an input sentence*/
int ampm;		/*am-0 pm-1*/
int retsen;		/*return sentence flag*/
int slot,channel;	/*tv variables*/
int onepic;		/*flag for one picture*/
int telpic;		/*telescope picture*/
int qflg;		/* quit flag*/
int spec[NUMSPEC];  	/*special flags  (0-tv,1-sh,ba,2-timr,3-commas,4-carscene)*/
			/*5-movement 6-regular putout 7-phone 8-mom 9-package
			10-17=delivered,18-trash,19-stock,20-robot,21-car
			door unlocked,22-got out of car at 57,23-(0 earth
			1 moon, 2-port1, 5-elev1,) 24-#ofitems ret*/
int sent[10];   	/*sentence in numbers*/

int cash,cash0;
int del,inv;  /*delay #of inv items*/
int c2,c3;
int moonindx,shipindx;  /*moon index*/

main()
{
int g_driver, g_mode, g_error;
int b,c,count;		/*  pause counter */
int locolor;		/*  local color */
unsigned lcnt;  /*long counter*/
int lb;			/*  brush number */
float hypot;
char ch,ch1,ch2,key[2];		/*key*/
int ich,ich1,ich2;		/*int-<char*/
char tstr[SLEN],tstr2[SLEN];
int lobrush;		/*local brush*/

/*run character maker*/
system("CHAR.EXE");
/*detect graphics */
detectgraph(&g_driver, &g_mode);

if (g_driver < 0)
   {
   printf("No graphics hardware detected!\n");
   exit(1);
   }
g_mode = VGAMED;    /*   VGAMED  = 640x350 2 page   */
		    /*   VGAHI   = 640x480 1 page   */
		    /*   EGAHI	 = 640x350 2 page   */

/*initialize graphics  */
initgraph(&g_driver, &g_mode, "");
g_error = graphresult();
if (g_error < 0)
   {
   printf("initgraph error: %s.\n", grapherrormsg(g_error));
   exit(1);
   }
if (registerbgifont(gothic_font) <0) exit(1);
if (registerbgifont(triplex_font) <0) exit(1);
if (registerbgifont(small_font) <0) exit(1);
if (registerbgifont(sansserif_font) <0) exit(1);
getdate(&today);  	/*get today's date*/
today.da_year=2020;	/*set tomarrow's date*/

gettime(&utime);       /*get user's time*/  /*set my time*/
mtime.ti_hour=6;  mtime.ti_min=0;  mtime.ti_sec=0; mtime.ti_hund=0;
page=0;
desc();    /*load descriptions*/
setvisualpage(!page);
setactivepage(page);

dx=dy=dx2=dy2=0;     doorflag=0;   midx=midy=0;   redraw=1; onemo=1;
radx=0; rady=0;     speed=5;  brush=0;   ex2=0;   cur=0;
lcolor=0;   ex=0;  curloc=0;   curobj=-1;
onepic=0;  telpic=90;  c2=(10-speed);   c3=(10-speed);
slot=0;  channel=0;   qflg=0;  b=0; moonindx=0; shipindx=0;

  init_var();
  load_file();        /*load title picture*/
  setfillstyle(SOLID_FILL, 15);
  bar(0,0,640,300);   /*white top */
  setfillstyle(SOLID_FILL, 0);
  bar(0,301,640,350);   /*black bottom */
  draw_it();		/*draw title picture*/
  setvisualpage(page);     /*show title*/
  load_obj();		/*load objects*/
  load_mobj();          /*load moving objects*/
  load_events(eve);	/*load events*/
  setactivepage(!page);    /*flip to page 1*/
  setfillstyle(SOLID_FILL, 15);
  bar(0,0,640,32);   /*white top */
  alloc_lines();
  alloc_lines3();      /*allocate memory for char lines*/
  lflag=2;     /*flag=ted*/
  load_traits("TED");
  for(c=0;c<=8;c++)
    skin3[c]=skin[c];
  load_file(); 		/*load ted character*/
  lflag=0;
  draw_it();	/*draw ted on page 1*/
  getrobot();	/*get image of ted*/
  setfillstyle(SOLID_FILL, 0);
  bar(0,0,640,300);   /*black top */
  for (c=0;c<4;c++)
    {
    lflag=3;     /*flag=object(heli)*/
    curobj=c+24;
    load_file();   /*load heli*/
    draw_it();	/*draw heli on page 1*/
    lflag=0;
    }
  alloc_lines2();      /*allocate memory for heli lines*/
  getheli();	/*get image of heli*/
/*  setvisualpage(!page);*/
  for(c=0;c<NUMMOBJ;c++)			/*draw objects*/
  {
  draw_mo(c);
  if (c<NUMCAR)
    getcar(c);
  if (c>=NUMCAR && c<NUMCAR+NUMROAD)
    getroad(c-NUMCAR);
  if (c>=NUMCAR+NUMROAD)
    getspike(c-NUMCAR-NUMROAD);
/*  getch();*/
  }

  setactivepage(page);     /*flip back to page 0*/
  x1=x2=x3=x4=TITX;       /*set current coord*/
  y1=y2=y3=y4=TITY;
  getlines3();
  putimage(x3,y3,robot[6],COPY_PUT);	/*draw ted on page 0*/
  putlines3();
  draw_heli();
  setactivepage(!page);  /*page 1 active*/
  load_file();        /*load title picture*/
  setfillstyle(SOLID_FILL, 15);
  bar(0,0,640,300);   /*white top */
  setfillstyle(SOLID_FILL, 0);
  bar(0,301,640,350);   /*black bottom */
  draw_it();		/*draw title picture*/
  putimage(x3,y3,robot[6],COPY_PUT);	/*draw ted on page 0*/
  putlines3();

  while (kbhit()==0)    /*while no key press*/
    {
    for(c=0;c<4;c++)
      {
      obj[c+24].p[0]=obj[c+24].p[0]-SPEEDH;  /*move heli to left*/
      if (obj[c+24].p[0]<=0) obj[c+24].p[0]=638;
      }
    draw_heli();
    setvisualpage(!page);
    delay(0);   delay(del);
    setactivepage(page);
    erase_heli();
    for(c=0;c<4;c++)
      {
      obj[c+24].p[0]=obj[c+24].p[0]-SPEEDH;  /*move heli to left*/
      if (obj[c+24].p[0]<=0) obj[c+24].p[0]=638;
      }
    draw_heli();
    setvisualpage(page);
    delay(0);   delay(del);
    setactivepage(!page);
    erase_heli();
    }   /*end while no kbhit*/
  ch=getch();
  if(ch==0)  getch();
  setactivepage(!page);
  setfillstyle(SOLID_FILL, 15);
  bar(0,0,640,32);   /*white top */
  setfillstyle(SOLID_FILL, 0);
  bar(0,301,640,350);   /*black bottom */
  load_traits("DEF");
  lflag=1;
  load_file();	/*load character file*/
  chrcur=cur;
  lflag=0;
  draw_it();	/*draw default charact0er*/
  getman();
  alloc_lines();      /*allocate memory for lines*/
  init_var2();
  strcpy(command,"");
  strcpy(precom,"");
  init_mob();
  init_ob();
  /*del=320;*/
  del=3000;
while(ex2 == 0)		/*every new location starts here*/
{
x2=x1;  y2=y1;
if (spec[20]==2) {x4=x3;  y4=y3;}
if (curloc!=newloc)
  {curloc=newloc; 
if (spec[20]==2) curloc3=curloc;
if (curloc==58||curloc==59) {x1=x2=300; x3=x4=320;}}

if (curloc==60 || curloc==61 || curloc==75) spec[1]=3;  /*erase characters*/
if (curloc==62||curloc==76) spec[1]=0;  /*on moon*/
if (curloc==63&&obj[245].loc==-2) {obj[245].loc=63;}
if (curloc==63&&obj[245].loc==0) {obj[245].loc=-3; }
if (curloc==64&&obj[245].loc==-2) {obj[245].loc=64;}
if (curloc==64&&obj[245].loc==0) {obj[245].loc=-3; }
if (curloc==65&&obj[245].loc==-2) {obj[245].loc=65;}
if (curloc==65&&obj[245].loc==0) {obj[245].loc=-3; }
if (curloc==75) {spec[20]=0;}
if (onepic>0) {newloc=curloc;  curloc=onepic;}
spec[4]=0;
if (curloc>7 && curloc<24) spec[4]=1;
if ((curloc<8||curloc>56)&&doorflag)
  {dx=0;  dy=0;  dx2=0;  dy2=0;}
for(count=0;count<2;count++)     /*draw picture on both pages*/
{
if (curloc==8||curloc==22||curloc==19)  getmob();
if (curloc==42||curloc==43)  {getbroad(); getbspike();}
if (curloc==56) obj[130].loc=56;
for (b=0;b<NUMCAR;b++)
  carx[b]=mobj[b].p[0];
for (b=0;b<NUMROAD;b++)
  roadx[b]=mobj[b+NUMCAR].p[0];
for (b=0;b<NUMSPIKE;b++)
  spikex[b]=mobj[b+NUMCAR+NUMROAD].p[0];
load_file();   /*load picture*/
if (spec[23]==3&&curloc==62) door[0].vis=0;
if (spec[23]==4&&curloc==62) door[1].vis=0;
if (spec[23]==5&&curloc==62) door[2].vis=0;
if (curloc==63)
  switch(spec[23]) {
    case 6:
      door[0].vis=0;  door[0].next=62;
      break;
    case 7:
      door[0].vis=0;  door[0].next=66;
      break;
    case 8:
      door[0].vis=0;  door[0].next=67;
      break;
    case 9:
      door[0].vis=0;  door[0].next=68;
      break;
    }
if (curloc==64)
  switch(spec[23]) {
    case 10:
      door[0].vis=0;  door[0].next=62;
      break;
    case 11:
      door[0].vis=0;  door[0].next=69;
      break;
    case 12:
      door[0].vis=0;  door[0].next=70;
      break;
    case 13:
      door[0].vis=0;  door[0].next=71;
      break;
    }
if (curloc==65)
  switch(spec[23]) {
    case 14:
      door[0].vis=0;  door[0].next=62;
      break;
    case 15:
      door[0].vis=0;  door[0].next=72;
      break;
    case 16:
      door[0].vis=0;  door[0].next=73;
      break;
    case 17:
      door[0].vis=0;  door[0].next=74;
      break;
    }
/*printf("DOORFLAG=%d\n",doorflag);*/
if (doorflag>0)
  {
  dorhit();
  onemo=1;
    x2=x1;  y2=y1;
    x4=x3;  y4=y3;
  }
if (!onepic&&count==1&&spec[1]!=2&&spec[1]!=3)
  {
    if (y1<=y3) get_char();
    if (spec[20]>=1&&curloc3==curloc)
      get_bot();
    if (y3<y1) get_char();
    if (curloc==42||curloc==43)
      {
      drroad();
      drspike();
      }
    if (y1<=y3)  draw_char();
    if (spec[20]>=1&&curloc3==curloc)
      draw_bot();
    if (y3<y1) draw_char();
    if (spec[4]==1)
      drmob();
  }
if (curloc==55) {mobj[14].loc=55; drmob();}
setvisualpage(page);
setactivepage(!page);
setfillstyle(SOLID_FILL, 15);
bar(0,0,640,300);   /*white top */
setfillstyle(SOLID_FILL, 0);
bar(0,301,640,350);   /*black bottom */
setusercharsize(1,1,1,1);
settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
setcolor(15);
oldcolor=lcolor;
lcolor=15;
setlinestyle(0,ULIN1,1);
lcolor=oldcolor;        /*initial line color */
draw_it();
lobrush=brush;
draw_cbrush(lobrush,oldcolor);
setfillstyle(SOLID_FILL, 0);
bar(0,301,640,350);   /*black bottom */
drob();         	/*draw objects*/
put_com();              /*put out cursor and command*/
page=!page;	/*flip pages*/
}   /*end for loop*/
doorflag=0;
setactivepage(page);
if (!onepic&&spec[1]!=2&&spec[1]!=3)
    {
    if (y1<=y3) get_char();
    if (spec[20]>=1&&curloc3==curloc)
      get_bot();
    if (y3<y1)  get_char();
    if (curloc==42||curloc==43)
      {
      drroad();
      drspike();
      }
    if (y1<=y3) draw_char();
    if (spec[20]>=1&&curloc==curloc3)
      draw_bot();
    if (y3<y1) draw_char();
    if (spec[4]==1)
	drmob();
    }
if (curloc==55)  {mobj[14].loc=55; drmob();}
setvisualpage(page);
if (curloc==61) dead();
if ((curloc==63||curloc==64||curloc==65)&&obj[245].loc==-3) obj[245].loc=-2;
else ex=0;
if (onepic)
  {
  putout(des[telpic]);    /*look at moon*/
  ch=getch();    /*get key*/
  if (ch==0)  getch();
  ex=1;
  onepic=0;
  }
while (ex == 0)    /*while there is no exit*/
  {
    if (curloc==55)  /*border*/
      bordr();
    if (curloc==60&&moonindx<6) {gotomoon(); moonindx++;}
    if (curloc==62&&spec[23]<2)
     {putout("You ran out of money and were stranded at the wrong moon port!");
      qflg=1; putout("Play Again (Y/N)");}
    if (curloc==75&&shipindx<6) {gotoship(); shipindx++;}
    if (curloc==77)
	   {putout("You are face to face with General Collins.  Around the room you see screens of different people in their homes.  You of course get caught and executed.  You are no longer alive.");
	     qflg=1; putout("Play Again (Y/N)");}
    gettime(&dtime);       /*get user's time*/
    if (dtime.ti_hund>utime.ti_hund)
      mtime.ti_hund=dtime.ti_hund-utime.ti_hund;
    else
      mtime.ti_hund=99-(utime.ti_hund-dtime.ti_hund);

   if (spec[1]==1)  /*take a shower*/
       {  setactivepage(page);  erase_char();  mtime.ti_hund=90;
       for (b=1;b<=600;b++)    /*600 sec= 10 minutes*/
	  { mtime.ti_sec++; timr(); check_eve();}
	   putout("Ten minutes pass.");/* get_char(); draw_char();*/
	    obj[21].loc=-2; spec[1]=0; mtime.ti_hund=0;
	    refresh();
	  setactivepage(!page);
       }
    else
     { if (spec[1]==2)  /*go to sleep*/
	{  setactivepage(page); mtime.ti_hund=90;
	  for (b=1;b<=1200;b++)    /*1200 sec= 20 minutes*/
	     { mtime.ti_sec++; timr(); check_eve();}
	  putout("Twenty minutes pass.");
	  spec[1]=0; mtime.ti_hund=0; obj[7].loc=-2; refresh();
	  setactivepage(!page);
	 }
      else
       {
       timr();
       if (!(check_eve()))
	  {
	  spec[4]=0;
	  if (curloc>7 && curloc<24) spec[4]=1;
	  if (dx!=0||dy!=0||spec[4]==1)  spec[5]=1; /* have to flip pages*/
		else  spec[5]=0;
	  if (spec[20]>=1&&curloc3==curloc)  mvbot();
	  if (dx2!=0||dy2!=0) spec[5]=1;
	  if (spec[5]==1)		/*we need to flip pages*/
	    {                             /* (we have moving objects)*/
	    if (onemo==1&&spec[1]!=3)
	      {
	      one();
	      onemo=0;
	      }
	    dir_char();
	    if (spec[20]>=1&&curloc3==curloc)
	      dir_bot();
	    mvmob();
	    bhit();
	    if (hitflag>0&&hitflag<5)
	      dorcheck();
	    obhit();
	    if (hitflag==0)
	      {
	      if ((curloc!=42&&curloc!=43)||(curloc==42&&dx<0)||(curloc==43&&dx>0))
		x1 += dx;
	      y1 += dy;
	      }
	    hitflag=0;            /*fix boundaries*/
	    if (spec[20]>=1&&curloc3==curloc)
		{
		x3 += dx2;
		y3 += dy2;
		}
	    if (curloc==42||curloc==43)
		{mvroad(); mvspike();}
	    if (x1<0)  {x1 = 0; hitflag=1;}
	    if (y1<0)  {y1 = 0; hitflag=2;}
	    if (x1>639-WMAN) {x1 = 639-WMAN; hitflag=3;}
	    if (y1>300-HMAN-1) {y1 = 300-HMAN-1; hitflag=4;}
	    setactivepage(!page);		/*go to second screen*/
	    if (spec[1]!=3)
	      {
	      if (y1<=y3)
		get_char();
	      if (spec[20]>=1&&curloc3==curloc)
		get_bot();
	      if (y3<y1) get_char();
	      }
	    if (curloc==42||curloc==43)
	      {
	      drroad();
	      drspike();
	      }
	    if (spec[1]!=3)
	      {
	      if (y1<=y3)
		draw_char();
	      if (spec[20]>=1&&curloc3==curloc)
		draw_bot();
	      if (y3<y1)  draw_char();
	      }
	    if (spec[4]==1)
	      drmob();
	    setvisualpage(!page);                    /*show character*/

	    delay(0);
	    delay(del);
	    if (spec[4]==1)
	      mobhit();
	    setactivepage(page);                    /*go to old (1st) page*/
	    if (curloc==42||curloc==43)
		{
		erase_road();
		erase_spike();
		}
	    if (spec[4]==1)
	      erase_mob();   /*erase moving objects*/
	    if (spec[1]!=3)
	      {
	      if (y1<=y3)
		erase_char();
	      if (spec[20]>=1&&curloc3==curloc)
		erase_bot();
	      if (y3<y1)
		erase_char();
	      }
	    page=!page;
	    if (curloc!=newloc)
	      refresh();
	    } /*end spec[5] flag*/
	  }    /*end if no event happened*/
	}     /*end sleep*/
     }       /*end shower*/

  if (kbhit() != 0)
    {
    ch = getch();
    key[0]=ch;  key[1]=0;
    if (ch == 0)  ch2= getch();
    switch (ch)
      {
      case 0:
	switch(ch2)
	  {
	  case 15:
	    putinv();
	    break;
	  case 59:			/*F1*/
	    menu();
	    break;
	  case 60:
	    save_game();
	    break;
	  case 61:			/*F3*/
	    strcpy(command,precom);
	    cursx=precur;
	    setactivepage(!page);
	    setfillstyle(1,0);
	    bar(16,cursy,639,cursy+16);
	    put_com();
	    setactivepage(page);
            setfillstyle(1,0);
	    bar(16,cursy,639,cursy+16);
	    put_com();
	    break;
	  case 62:
	    restore_game();
	    break;
	  case 63:
	    hint();
	    break;
	  case 68:			/*F10*/
	    /*del=del+300;
	    if (del>900) del=20;*/
	    del=del+1000;
          if (del>10000) del=20;
	    break;
	  case 71:			/*up-left */
	    if (spec[1]!=3)
	      {
	      dx = -speed;
	      dy = -speed;
	      mode=1;
	      }
	    break;
	  case 72:			/*up arrow*/
	    if (spec[1]!=3)
	      {
            if (dx !=0 || dy !=0) /*already moving=stop*/
		  {
		  dx=dy=0; 	
              }
            else
              {
	        dx = 0;
	        dy = -speed;
	        mode=2;
              }
	      }
	    break;
	  case 73:			/*up-right*/
	    if (spec[1]!=3)
	      {
	      dx = speed;
	      dy = -speed;
	      mode=4;
	      }
	    break;
	  case 75:			/*left arrow*/
	    if (spec[1]!=3)
	      {
            if (dx !=0 || dy !=0) /*already moving=stop*/
		  {
		  dx=dy=0; 	
              }
            else
              {
	        dx = -speed;		/*change in x is -1 */
	        dy = 0;
	        mode=1;
              }
	      }
	    break;
	  case 76:		/*5-stop*/
	    dx=0;
	    dy=0;
/*	    mode=3; */
	    break;
	  case 77: 			/*right arrow*/
	    if (spec[1]!=3)
	     {
            if (dx !=0 || dy !=0) /*already moving=stop*/
		  {
		  dx=dy=0; 	
              }
            else
              {
   	        dx = speed;
	        dy = 0;
	        mode=4;
              }
	      }
	   break;
	 case 79:			/*down-left*/
	    if (spec[1]!=3)
	     {
	     dx = -speed;
	     dy = speed;
	     mode=1;
	     }
	   break;
	 case 80:			/*down arrow*/
	    if (spec[1]!=3)
	     {
            if (dx !=0 || dy !=0) /*already moving=stop*/
		  {
		  dx=dy=0; 	
              }
            else
              {
 	        dx = 0;
	        dy = speed;
	        mode=0;
              }
	     }
	   break;
	 case 81:			/*down-right*/
	    if (spec[1]!=3)
	     {
	     dx = speed;
	     dy = speed;
	     mode=4;
	     }
	   break;
	  }	/*end extended keys switch*/
	break;
      case 8:			/*  backspace*/
	if (cursx>16)
	  {
	  setfillstyle(SOLID_FILL,0);
	  setactivepage(page);
	  bar(cursx-16,cursy,cursx+16,cursy+16);
	  setactivepage(!page);
	  bar(cursx-16,cursy,cursx+16,cursy+16);
	  command[strlen(command)-1]=0;
          cursx=cursx-16;
	  draw_cursor();
	  }
	break;
      case 9:			/*'TAB'*/
      case 11:
	putinv();
	break;
      case 13:			/* '<cr>'  carriage return*/
	strcpy(precom,command);	/*save old command*/
	strcpy(it,command);
	spec[3]=1;   /*set flag to ignore commas, periods*/
	make_words();
	spec[3]=0;
	match_words();
	setfillstyle(SOLID_FILL,0);
	precur=cursx;		/*save cursor*/
        cursx=16;		/*reset cursor*/
	setactivepage(page);
	bar(16,310,639,349);		/*blackout old sentence*/
	draw_cursor();
	setactivepage(!page);
	bar(16,310,639,349);		/*blackout old sentence*/
	draw_cursor();
	strcpy(command,"");
	break;
      case 27:	/*esc*/
	quit();
	break;
      case 43:			/* '+' speed up*/
	if (speed<8) speed++;
	dx=(dx>0)*speed-(dx<0)*speed;
	dy=(dy>0)*speed-(dy<0)*speed;
	break;
      case 45:			/* '-' slow down*/
	if (speed>1) speed--;
	dx=(dx>0)*speed-(dx<0)*speed;
	dy=(dy>0)*speed-(dy<0)*speed;
	break;
      default:		/*alpha or other symbol*/
	if (cursx<592)     /*608*/
	  {
	  setcolor(15);
	  setfillstyle(SOLID_FILL,0);
	  settextstyle(0,0,2);
	  setactivepage(page);
	  bar(cursx,cursy,cursx+16,cursy+16);  /*blackout cursor*/
	  outtextxy(cursx,cursy,key);
	  setactivepage(!page);
	  bar(cursx,cursy,cursx+16,cursy+16);  /*blackout cursor*/
	  outtextxy(cursx,cursy,key);
	  cursx=cursx+16;
	  strcat(command,key);
	  draw_cursor();
	  }
	break;
      }                            /*end switch*/
   }                           /*end if kbhit*/
   if (hitflag==6)  {hitflag=0;
	putout("You were hit by a car.  Now you are dead.");  dead();}
  }                             /*end while*/
}		/*end 2nd while*/
closegraph();
}	       /*end main*/

quit()
{
qflg=2;
putout("Quit? (Y/N)");
}

erase_char()
{  putimage(x2,y2,screen[page],COPY_PUT);
}

erase_bot()
{  putimage(x4,y4,screen3[page],COPY_PUT);
}

get_char()
{   /*get background*/
    getimage(x1,y1,x1+WMAN,y1+HMAN,screen[!page]);
    getlines(); 	/*getimage lines*/
}

get_bot()
{   /*get background*/
    getimage(x3,y3,x3+WMAN,y3+HMAN,screen3[!page]);
    getlines3(); 	/*getimage lines*/
}

draw_char()
{
    /*put character on screen*/
    putimage(x1,y1,man[numimg],COPY_PUT);
    putlines();	/*putimage lines*/
}

draw_bot()
{
    /*put robot on screen*/
    putimage(x3,y3,robot[numimg3],COPY_PUT);
    putlines3();	/*putimage lines*/
}

erase_heli()
{
int c;

for(c=0;c<4;c++)
  {
  if (obj[c+24].p[0]==638)
    putimage(SPEEDH,obj[c+24].p[1],screen[c+1],COPY_PUT);
  else
    putimage(obj[c+24].p[0]+SPEEDH,obj[c+24].p[1],screen[c+1],COPY_PUT);
  }
}

draw_heli()
{
int c;

getlines2(); 	/*getimage lines*/
for(c=0;c<4;c++)
  {
  if (obj[c+24].p[0]==638)
    getimage(SPEEDH,obj[c+24].p[1],60+SPEEDH,obj[c+24].p[1]+24,screen[c+1]);
  else
    getimage(obj[c+24].p[0]+SPEEDH,obj[c+24].p[1],obj[c+24].p[0]+SPEEDH+60,obj[c+24].p[1]+24,screen[c+1]);
   /*put heli on screen*/
  putimage(obj[c+24].p[0],obj[c+24].p[1],heli[c],COPY_PUT);
  }
putlines2();	/*putimage lines*/
}

timr()
{
char temp[4];

    if (mtime.ti_hund>89&&spec[2]==0)
      {spec[2]=1;
       mtime.ti_sec++;}
    if ((mtime.ti_hund>30&&mtime.ti_hund<80)/*||(spec[1]==0)*/)
	spec[2]=0;
    if (mtime.ti_sec==60)
      {
      mtime.ti_sec=0;
      mtime.ti_min++;
      }
    if (mtime.ti_min==60)
      {mtime.ti_min=0;
      mtime.ti_hour++;}

    if (mtime.ti_hour==13)
      {
      mtime.ti_hour=1;
      ampm=1;
      }
    itoa(mtime.ti_hour,temp,10);
    if (mtime.ti_hour<10) strcat(strtim,"0");
    strcpy(strtim,temp);
    strcat(strtim,":");
    itoa(mtime.ti_min,temp,10);
    if (mtime.ti_min<10) strcat(strtim,"0");
    strcat(strtim,temp);
    strcat(strtim,":");
    itoa(mtime.ti_sec,temp,10);
    if (mtime.ti_sec<10) strcat(strtim,"0");
    strcat(strtim,temp);
    if (ampm)  strcat(strtim," pm.");
    else strcat(strtim," am.");
}

check_eve()      /*check time events*/
{
int c;
int evfl;

evfl=0;
    for(c=0;c<NUMEVE;c++)
	{				 /*make object visable*/
	if (mtime.ti_hour==eve[c].beg.ti_hour&&
	  mtime.ti_min==eve[c].beg.ti_min&&
	  mtime.ti_sec==eve[c].beg.ti_sec)
	  {
	  evfl=1;
	  if (c<NUMTV)   /*we are turning to a new slot*/
	    {
	    if (slot!=eve[c].obnum)
	      {
	      obj[slot*10+channel+30].loc=-2;   /*turn off old tv picture*/
	      slot=eve[c].obnum;
	      if (spec[0]==1)
		obj[slot*10+channel+30].loc=eve[c].loc;
	      if (curloc==eve[c].loc&&spec[0]==1)
		refresh();    /*end if we are in tv room and tv is on*/
	      }  /*end if we have not already turned slot*/
	    }  /*end if we are turning a slot*/
	  else
	      {
	      if (obj[eve[c].obnum].loc!=eve[c].loc)
		{
		obj[eve[c].obnum].loc=eve[c].loc;
		if (curloc==eve[c].loc)
		  refresh();
		if (c!=7)
		  {
		  if (obj[8].loc==-1)  {putout("You just received a phone call.");
					spec[7]=c-7;}
		  }
		else
		  {
		  if (obj[8].loc==-1)  putout("You just received a large package.");
		  }
		}    /*end if object is not already set*/
	      }  /*end if we are not turning a slot*/
	  } /*end if event time matches time now*/
						/*make object disappear*/
      if (mtime.ti_hour==eve[c].end.ti_hour&&
	  mtime.ti_min==eve[c].end.ti_min&&
	  mtime.ti_sec==eve[c].end.ti_sec&&
	  obj[eve[c].obnum].loc!=-2&&c>11)
	    {
	    evfl=1;
	    obj[eve[c].obnum].loc=-2;
	    refresh();
	    }
    }     /*end for all events*/
		    /*end of game event*/
      if (mtime.ti_hour==9 && mtime.ti_min==30 && mtime.ti_sec==0 &&
		curloc<55)
	  {
	  evfl=1;
	  spec[1]=0;  /*turn off shower*/
	  putout("Time is up.  You were caught and arrested for 'suspicious actions', a new crime.");
	  mtime.ti_hour=0;  mtime.ti_min=0;
	  qflg=1;
	  putout("Play Again? (Y/N)");
	  }        /*end game event*/
return(evfl);
}

put_com()		/*put out command*/
{
setcolor(15);
settextstyle(0,0,2);
outtextxy(0,310,">");			/*display cursor*/
outtextxy(16,310,command);		/*display current command*/
outtextxy(cursx,cursy,cursor);
}	/*end put_com*/

drob()
{
int d;

for(d=0;d<NUMOBJ;d++)			/*draw objects*/
  {
  if (obj[d].loc==curloc)
    draw_obj(d);
  }   /*end objects for loop*/
}	/*end drob*/

getmob()
{getimage(0,155,136,203,screen[6]);}

getbroad()
{getimage(100,179,172,180,screen[7]);}

getbspike()
{getimage(0,56,8,80,screen[8]);}

drmob()
{
int a;

for (a=0;a<NUMCAR;a++)
  {
  if (mobj[a].loc==curloc)
    {
    if (curloc==55&&a==14) putimage(423,112,car[14],COPY_PUT);
    else putimage(mobj[a].p[0],mobj[a].p[1],car[a],COPY_PUT);
    }
  }
}

drroad()
{
int a;

for (a=0;a<NUMROAD;a++)
  putimage(mobj[a+NUMCAR].p[0],mobj[a+NUMCAR].p[1],road[a],COPY_PUT);
}

drspike()
{
int a;

for (a=0;a<NUMSPIKE;a++)
  putimage(mobj[a+NUMCAR+NUMROAD].p[0],mobj[a+NUMCAR+NUMROAD].p[1],spike[a],COPY_PUT);
}

mvmob()
{
int a;

for (a=0;a<NUMCAR;a++)
  {
  carx[a]=mobj[a].p[0];
  if (a<15)
    {
    mobj[a].p[0]=mobj[a].p[0]-CARSPD;
    if (mobj[a].p[0]<0)
      {
      mobj[a].p[0]=500;
      mobj[a].loc++;
      if (mobj[a].loc>23)  mobj[a].loc=8;
      }
    }
  else
    {
    mobj[a].p[0]=mobj[a].p[0]+CARSPD;
    if (mobj[a].p[0]>500)
      {
      mobj[a].p[0]=4;
      mobj[a].loc--;
      if (mobj[a].loc<8)  mobj[a].loc=23;
      }
    }
  }
}

mvroad()
{
int a;

for (a=0;a<NUMROAD;a++)
  {
  roadx[a]=mobj[a+NUMCAR].p[0];
  mobj[a+NUMCAR].p[0]=mobj[a+NUMCAR].p[0]-dx;
  if (mobj[a+NUMCAR].p[0]<0)
    mobj[a+NUMCAR].p[0]=649-dx;
    if (mobj[a+NUMCAR].p[0]>649)
      mobj[a+NUMCAR].p[0]=-dx;
  }
}

mvspike()
{
int a;

for (a=0;a<NUMSPIKE;a++)
  {
  spikex[a]=mobj[a+NUMCAR+NUMROAD].p[0];
  mobj[a+NUMCAR+NUMROAD].p[0]=mobj[a+NUMCAR+NUMROAD].p[0]-dx;
  if (mobj[a+NUMCAR+NUMROAD].p[0]<0)
    mobj[a+NUMCAR+NUMROAD].p[0]=649-dx;
  if (mobj[a+NUMCAR+NUMROAD].p[0]>649)
    mobj[a+NUMCAR+NUMROAD].p[0]=-dx;
  }
}

erase_mob()
{
int a;

for (a=0;a<NUMCAR;a++)
  {
  if (a<15)
    {
    if (mobj[a].loc==curloc || (mobj[a].loc==curloc+1 && mobj[a].p[0]==500)||
       (curloc==23 && mobj[a].loc==8 && mobj[a].p[0]==500))
	  putimage(carx[a],mobj[a].p[1],screen[6],COPY_PUT);
    }
  else
    {
    if (mobj[a].loc==curloc || (mobj[a].loc==curloc-1 && mobj[a].p[0]==4)||
       (curloc==8 && mobj[a].loc==23 && mobj[a].p[0]==4))
	  putimage(carx[a],mobj[a].p[1],screen[6],COPY_PUT);
    }
  }
}

erase_road()
{
int a;

for (a=0;a<NUMROAD;a++)
  {
  putimage(roadx[a],mobj[a+NUMCAR].p[1],screen[7],COPY_PUT);
  }
}

erase_spike()
{
int a;

for (a=0;a<NUMSPIKE;a++)
  {
  putimage(spikex[a],mobj[a+NUMCAR+NUMROAD].p[1],screen[8],COPY_PUT);
  }
}

draw_mo(int d)
{
    setfillstyle(SOLID_FILL, 15);      /*white box*/
    bar(mobj[d].p[0],mobj[d].p[1],
	mobj[d].p[0]+mobj[d].p[2],mobj[d].p[1]+mobj[d].p[3]);
    curobj=d;
    draw_mobj();
}

draw_cbrush(int lbrush,int col)
{
free(brushbuff);
free(cbuff);
setfillstyle(SOLID_FILL, 15);      /*clear current brush area*/
bar(CURX-9,CURY,CURX+9,CURY+18);
csize = imagesize(CURX,CURY,CURX+lbrush,CURY+lbrush);
cbuff=malloc(csize);
size = imagesize(CURX,CURY,CURX+lbrush,CURY+lbrush);
brushbuff=malloc(size);
setfillstyle(SOLID_FILL, 7);
switch (lbrush)
  {
  case 0:
     putpixel(CURX,CURY,7);    /*brush 0*/
     getimage(CURX,CURY,CURX,CURY,cbuff);
     setfillstyle(SOLID_FILL, col);
     break;
  case 1:
     bar(CURX,CURY,CURX+1,CURY+1);  /*brush 1*/
     getimage(CURX,CURY,CURX+1,CURY+1,cbuff);
     setfillstyle(SOLID_FILL, col);
     break;
  case 2:
     bar(CURX,CURY,CURX+2,CURY+2);  /* brush 2*/
     getimage(CURX,CURY,CURX+2,CURY+2,cbuff);
     setfillstyle(SOLID_FILL, col);
     break;
  case 3:
     bar(CURX,CURY,CURX+3,CURY+3);  /*brush 3*/
     getimage(CURX,CURY,CURX+3,CURY+3,cbuff);
     setfillstyle(SOLID_FILL, col);
     break;
  case 4:
     bar(CURX,CURY,CURX+4,CURY+4);  /*brush 4*/
     getimage(CURX,CURY,CURX+4,CURY+4,cbuff);
     setfillstyle(SOLID_FILL, col);
     break;
  case 5:
     bar(CURX,CURY,CURX+5,CURY+5);  /*brush 5*/
     getimage(CURX,CURY,CURX+5,CURY+5,cbuff);
     setfillstyle(SOLID_FILL, col);
     break;
  case 6:
     bar(CURX,CURY,CURX+6,CURY+6);  /*brush 6*/
     getimage(CURX,CURY,CURX+6,CURY+6,cbuff);
     setfillstyle(SOLID_FILL, col);
     break;
  case 7:
     bar(CURX,CURY,CURX+7,CURY+7);  /*brush 7*/
     getimage(CURX,CURY,CURX+7,CURY+7,cbuff);
     setfillstyle(SOLID_FILL, col);
     break;
  case 8:
     setfillstyle(LINE_FILL,7);
     bar(CURX,CURY,CURX+8,CURY+8);  /*brush 8*/
     getimage(CURX,CURY,CURX+8,CURY+8,cbuff);
     setfillstyle(LINE_FILL, col);
     break;
  case 9:
     setfillstyle(CLOSE_DOT_FILL, 7);
     bar(CURX,CURY,CURX+9,CURY+9);  /*brush 9*/
     getimage(CURX,CURY,CURX+9,CURY+9,cbuff);
     setfillstyle(CLOSE_DOT_FILL, col);
     break;
  case 10:
     setfillstyle(CLOSE_DOT_FILL, 7);
     bar(CURX,CURY,CURX+10,CURY+10);  /*brush 10*/
     getimage(CURX,CURY,CURX+10,CURY+10,cbuff);
     setfillstyle(CLOSE_DOT_FILL, col);
     break;
  }
bar(CURX,CURY,CURX+lbrush,CURY+lbrush);
getimage(CURX,CURY,CURX+lbrush,CURY+lbrush,brushbuff);
}

draw_it()
{
int xx1,yy1,xx2,yy2;	/*draw_it point coords*/
int c,radius,d,mcolor;
struct action tact[1];

lcolor=0;  brush=0;
setcolor(lcolor);
setlinestyle(0,ULIN1,1);
draw_cbrush(brush,lcolor);        /*get current color and size brush*/
act2=act1;    /*save start of list*/
for (c=0;c<cur;c++)
   {
   tact[0].name=act2->name;
   tact[0].a[0]=act2->a[0];
   tact[0].a[1]=act2->a[1];
   tact[0].a[2]=act2->a[2];
   tact[0].a[3]=act2->a[3];
   tact[0].a[4]=act2->a[4];
   strcpy(tact[0].str,act2->str);
   if (curobj>-1) 	/*we are drawing an object*/
     {
     d=tact[0].name;
     if (d>2)                    /*2 point translation*/
       {
       if (lflag==3)
	 {
	 tact[0].a[0]+=obj[curobj].p[0];       /*add offsets*/
	 tact[0].a[1]+=obj[curobj].p[1];
	 }
       else
	 {
	 tact[0].a[0]+=mobj[curobj].p[0];       /*add offsets*/
	 tact[0].a[1]+=mobj[curobj].p[1];
	 }
       }
     if (d==4 || d==6 || d==10)	/*4 point translation*/
       {
       if (lflag==3)
	 {
	 tact[0].a[2]+=obj[curobj].p[0];       /*add offsets*/
	 tact[0].a[3]+=obj[curobj].p[1];
	 }
       else
	 {
	 tact[0].a[2]+=mobj[curobj].p[0];       /*add offsets*/
	 tact[0].a[3]+=mobj[curobj].p[1];
	 }
       }
     }    /*end if we are drawing object*/
   switch (tact[0].name)
      {
      case 0:
	lcolor=tact[0].a[0];
	setcolor(lcolor);
	setfillstyle(1,lcolor);
	draw_cbrush(brush,lcolor);    /*get current color and size brush*/
	break;
      case 1:
	brush=tact[0].a[0];
	draw_cbrush(brush,lcolor);    /*get current color and size brush*/
	break;
      case 2:
	lstyle=tact[0].a[0];
	setlinestyle(lstyle,ULIN1,2*(brush>0)+1);
	break;
      case 3:
	xx1=tact[0].a[0];
	yy1=tact[0].a[1];
	putimage(xx1,yy1,brushbuff,COPY_PUT);
	break;
      case 4:
	setfillstyle(1,lcolor);
	setlinestyle(lstyle,ULIN1,2*(brush>0)+1);
	xx1=tact[0].a[0];
	yy1=tact[0].a[1];
	xx2=tact[0].a[2];
	yy2=tact[0].a[3];
	line(xx1,yy1,xx2,yy2);
	break;
      case 5:
	setlinestyle(lstyle,ULIN1,2*(brush>0)+1);
	xx1=tact[0].a[0];
	yy1=tact[0].a[1];
	radius=tact[0].a[2];
	circle(xx1,yy1,radius);
	break;
      case 6:
	setlinestyle(lstyle,ULIN1,2*(brush>0)+1);
	xx1=tact[0].a[0];
	yy1=tact[0].a[1];
	xx2=tact[0].a[2];
	yy2=tact[0].a[3];
	rectangle(xx1,yy1,xx2,yy2);
	break;
      case 7:
	xx1=tact[0].a[0];
	yy1=tact[0].a[1];
	border=tact[0].a[2];
	pattern=tact[0].a[3];
	if (pattern==15)  mcolor=tact[0].a[4];
	if (pattern == 12)
	      setfillpattern(upat1,lcolor);
	   else
	      if (pattern == 13)
		 setfillpattern(upat2,lcolor);
	      else
                 if (pattern == 14)
		   setfillpattern(upat3,lcolor);
		 else
		   setfillstyle(pattern,lcolor);
	if (pattern !=15)
	     floodfill(xx1,yy1,border);
	   else
	     floodwfill(xx1,yy1,border,lcolor,mcolor);
	break;
      case 8:
	xx1=tact[0].a[0];
	yy1=tact[0].a[1];
	style=tact[0].a[2];
	direction=tact[0].a[3];
	tsize=tact[0].a[4];
	settextstyle(style,direction,tsize);
	setusercharsize(tsize+1,1,tsize+1,1);
	outtextxy(xx1,yy1,tact[0].str);
	break;
      case 9:
	xx1=tact[0].a[0];
	yy1=tact[0].a[1];
	radx=tact[0].a[2];
	rady=tact[0].a[3];
	ellipse(xx1,yy1,SANG,EANG,radx,rady);
	break;
      case 10:
        setfillstyle(1,lcolor);
	xx1=tact[0].a[0];
	yy1=tact[0].a[1];
	xx2=tact[0].a[2];
	yy2=tact[0].a[3];
	bar(xx1,yy1,xx2,yy2);
	break;
      }     	/*end switch*/
   act2=act2->next;    /*move up the list*/
   }		/*end for*/
act2=act1;   /*go back to beginning*/
act3=act1;
for (c=0;c<cur;c++)
  {
  act1=act2->next;
  free(act2);
  act2=act1;
  }
free(act1);
curobj=-1;
/*setcolor(0);*/
setfillstyle(SOLID_FILL, 0);
bar(0,301,640,350);   /*black bottom */
}   /*end draw_it*/

floodwfill(int sx, int sy, int lb, int lc1,int lc2)    /*flood fill shape with white*/
{
mofillxy(sx,sy,lb,lc1,lc2,0,-1,-1);
mofillxy(sx, sy-1, lb, lc1, lc2, 0, -1, 1);
mofillxy(sx, sy, lb, lc1, lc2, 0, 1, -1);
mofillxy(sx, sy+1, lb, lc1, lc2, 0, 1, 1);
}

mofillxy(int sx,int sy,int lb,int lc1,int lc2,int lcf,int xd,int yd)
{
if (getpixel(sx,sy)!=lb && (sx>-1) &&  (sy>-1) && (sx<640) && (sy<301))
  {
  mofillx(sx, sy, lb, lc1, lc2,lcf,xd,yd);
  mofillxy(sx,sy+yd,lb,lc1,lc2,lcf,xd,yd);
  }
}

mofillx(int sx,int sy, int lb, int lc1, int lc2, int lcf, int xd, int yd)
{
int lc3;

if (getpixel(sx,sy)!=lb && (sx>-1) &&  (sy>-1) && (sx<640) && (sy<301))
  {
  if (lcf==1) lc3=lc1;
  else lc3=lc2;
  putpixel(sx,sy,lc3);
  mofillx(sx+xd,sy,lb,lc1,lc2,(lcf==0),xd,yd);
  }
}

mofilly(int sx,int sy, int lb, int lc1, int lc2, int lcf, int xd, int yd)
{
int lc3;

if (getpixel(sx,sy)!=lb && (sx>-1) &&  (sy>-1) && (sx<640) && (sy<301))
  {
  if (lcf==1) lc3=lc1;
  else lc3=lc2;
  putpixel(sx,sy,lc3);
  mofillx(sx,sy+yd,lb,lc1,lc2,(lcf==0),xd,yd);
  }
}

load_file()
{
FILE *fptr;
char nm2[256],nm3[256],nm[256];
int a;
struct action tact[1];

a=0;
getcwd(PATH,512);
strcat(PATH,LPATH);
switch (lflag)
  {
  case 0:
  case 5:
    itoa(curloc,nm,10);
    strcpy(nm2,PATH);
    strcat(nm2,nm);
    strcpy(nm3,nm2);
    strcpy(nm,nm2);
    if (curloc==0)
      strcat(nm,".PLY");
    else
      strcat(nm,".PIC");
    break;
  case 1:
    strcpy(nm,PATH);
    strcat(nm,"DEF.PIC");
    break;
  case 2:
    strcpy(nm,PATH);
    strcat(nm,"TED.PIC");
    break;
  case 3:
    strcpy(nm,PATH);
    strcat(nm,"OBJ");
    itoa(curobj,nm2,10);
    strcat(nm,nm2);
    strcat(nm,".PIC");
    break;
  case 4:
    strcpy(nm,PATH);
    strcat(nm,"MOBJ");
    itoa(curobj,nm2,10);
    strcat(nm,nm2);
    strcat(nm,".PIC");
    break;
  }
if ( (fptr=fopen(nm,"rb"))==NULL)
   {printf("Can't open file %s",nm); getch(); }
else
   {
   act1=malloc(sizeof(struct daction));   /*make first link*/
   act2=act1;   /*save beginning of list*/
     while( fread(&tact[0],sizeof(tact[0]),1,fptr)==1)
	{
	act2->name=tact[0].name;
	act2->a[0]=tact[0].a[0];
	act2->a[1]=tact[0].a[1];
	act2->a[2]=tact[0].a[2];
	act2->a[3]=tact[0].a[3];
	act2->a[4]=tact[0].a[4];
	strcpy(act2->str,tact[0].str);
	act2->next=malloc(sizeof(struct daction));   /*allocate next link*/
	act2=act2->next;    /*move up the list*/
	a++;
	}
     cur=a;
   }
fclose(fptr);
if (lflag==0)
  {
  if (curloc!=0)
    {
    strcat(nm3,".DOR");
    if ( (fptr=fopen(nm3,"rb"))==NULL)
       {printf("Can't open file %s",nm3); getch(); }
    else
       fread(&door,sizeof(door[0]),NUMDOR,fptr);
    fclose(fptr);
    }
  strcat(nm2,".EDG");
  if ( (fptr=fopen(nm2,"rb"))==NULL)
     {printf("Can't open file %s",nm2); getch(); }
  else
     {
     fread(&pntx[0],sizeof(pntx[0]),4,fptr);
     fread(&pnty[0],sizeof(pnty[0]),4,fptr);
     }
  fclose(fptr);
  }
}

load_obj()
{
FILE *fptr;
char nm[256],nm2[256];
int a;
struct tmpobj
  {
  char name[11];
  int p[4];
  int loc;
  };
struct tmpobj tmpo[1];

a=0;
getcwd(PATH,512);
strcat(PATH,LPATH);

for(a=0;a<NUMOBJ;a++)
  {
  strcpy(nm,PATH);
  strcat(nm,"OBJ");
  itoa(a,nm2,10);
  strcat(nm,nm2);
  strcat(nm,".FIL");
  if ( (fptr=fopen(nm,"rb"))==NULL)
     {printf("Can't open file %s",nm); getch(); }
  else
     {
     fread(&tmpo,sizeof(tmpo[0]),1,fptr);
     }
  fclose(fptr);
  strcpy(obj[a].name,tmpo[0].name);
  obj[a].p[0]=tmpo[0].p[0];  obj[a].p[1]=tmpo[0].p[1];
  obj[a].p[2]=tmpo[0].p[2];  obj[a].p[3]=tmpo[0].p[3];
  obj[a].loc=tmpo[0].loc;
  } 			/*end for*/
}

load_mobj()
{
FILE *fptr;
char nm[256],nm2[256];
int a;
struct tmpobj
  {
  char name[11];
  int p[4];
  int loc;
  };
struct tmpobj tmpo[1];

a=0;
getcwd(PATH,512);
strcat(PATH,LPATH);

for(a=0;a<NUMMOBJ;a++)
  {
  strcpy(nm,PATH);
  strcat(nm,"MOBJ");
  itoa(a,nm2,10);
  strcat(nm,nm2);
  strcat(nm,".FIL");
  if ( (fptr=fopen(nm,"rb"))==NULL)
     {printf("Can't open file %s",nm); getch(); }
  else
     {
     fread(&tmpo,sizeof(tmpo[0]),1,fptr);
     }
  fclose(fptr);
  strcpy(mobj[a].name,tmpo[0].name);
  mobj[a].p[0]=tmpo[0].p[0];  mobj[a].p[1]=tmpo[0].p[1];
  mobj[a].p[2]=tmpo[0].p[2];  mobj[a].p[3]=tmpo[0].p[3];
  mobj[a].loc=tmpo[0].loc;
  } 			/*end for*/
}

draw_obj(int d)
{
int tfl;
if (curloc==56) {  obj[130].p[0]=424;  obj[130].p[1]=176;obj[130].loc=56;}
if (spec[22]==1) {x1=x2=400; y1=y2=200; x3=x4=380; y3=y4=180; }
    setfillstyle(SOLID_FILL, 15);      /*white box*/
    bar(obj[d].p[0],obj[d].p[1],
	obj[d].p[0]+obj[d].p[2],obj[d].p[1]+obj[d].p[3]);
    curobj=d;
tfl=lflag;
lflag=3;
load_file();
if (curloc==56) {  obj[130].p[0]=424;  obj[130].p[1]=176; obj[130].loc=56;}
if (spec[22]==1) {x1=x2=400; y1=y2=200; x3=x4=380; y3=y4=180;  spec[22]=0;}
draw_it();	/*draw object*/
lflag=tfl;
    setfillstyle(SOLID_FILL, 0);
    bar(0,301,640,350);   /*black bottom */
}

draw_mobj()
{
int tfl,a;

tfl=lflag;
lflag=4;
load_file();
draw_it();	/*draw object*/
lflag=tfl;
}

load_traits(char lname[11])
{
#define BUFF1 11
#define BUFF2 8
char buff[BUFF1],buffs[BUFF2];
int inhandle,a;
char lnm2[256];
FILE *fptr;

a=0;
getcwd(PATH,512);
strcat(PATH,LPATH);
strcpy(lnm2,PATH);
strcat(lnm2,lname);
strcat(lnm2,".TXT");
if ( (inhandle=open(lnm2,O_RDONLY))<0)
   {printf("Can't open file %s",lnm2); getch(); }
else
   read(inhandle,name,BUFF1);
close(inhandle);
strcpy(lnm2,PATH);
strcat(lnm2,lname);
strcat(lnm2,".TRT");
if ( (fptr=fopen(lnm2,"rb"))==NULL)
   {printf("Can't open file %s",lnm2); getch(); }
else
   {
   while( fread(&skin[a],sizeof(skin[a]),1,fptr)==1 && a<8)
      a++;
   }
fclose(fptr);
}

bhit()
{
float m1,m2;		/*slopes of boundary checks*/
float diff0,diff1,diff2,diff3;
int a;

  diff1=pntx[1]-pntx[0];
  diff0=pnty[1]-pnty[0];
  diff2=x1+dx-pntx[0];
					/*line 0*/ /*left*/
  if ((diff1==0)&&(x1+dx<=pntx[0]))  hitflag=1;    /*vert line*/
  else
    {
    m1=abs((float)diff0/(diff1+!(diff1)));
    m2=abs((float)(y1+dy+HMAN-pnty[0])/(diff2+!(diff2)));

    if (m2>1.0) m2=1.0;
    if ((int)((m2-0.01)*100)<=(int)(m1*100)  &&
      (int)(m1*100)<=(int)((m2+0.01)*100)) hitflag=1;
    }
  /*line 2*/          /*right*/
  diff1=pntx[2]-pntx[3];
  diff0=pnty[2]-pnty[3];
  diff2=x1+dx+WMAN-pntx[3];
  diff3=y1+dy+HMAN-pnty[3];
  if ((diff1==0)&&(x1+dx+WMAN>=pntx[2]))  hitflag=3;     /*vert*/
    else
      {
      m1=abs((float)diff0/(diff1+!(diff1)));
      m2=abs((float)diff3/(diff2+!(diff2)));
          if (m2>1.0) m2=1.0;
      if (diff2==0 && diff3==0) hitflag=3;
      if ((int)(m1*100) == (int)(m2*100)) hitflag=3;
      if ((int)((m2-0.01)*100) <= (int)(m1*100) &&
	 (int)(m1*100)<= (int)((m2+0.01)*100)) hitflag=3;
      }
  /*line 1*/       /*top*/
  diff0=pnty[2]-pnty[1];
  diff1=pntx[2]-pntx[1];
  diff2=x1+dx-pntx[1];
  if (diff0==0)
    {if ((y1+dy+HMAN<=pnty[2])||(pnty[2]==0&&y1+dy<0)) hitflag=2;}
  else
    {
    m1=(float)diff0/(diff1+!(diff1));
    m2=(float)(y1+dy+HMAN-pnty[1])/(diff2+!(diff2));
    if ((int)((m1-0.1*speed)*10)<=(int)(m2*10)  &&
      (int)(m2*10)<=(int)((m1+0.1*speed)*10)) hitflag=2;
    }
  /*line 3*/           /*bottom*/
  diff0=pnty[0]-pnty[3];
  diff1=pntx[0]-pntx[3];
  diff2=x1+dx+WMAN-pntx[3];
  m1=(float)diff0/(diff1+!(diff1));
  m2=(float)(y1+dy+HMAN-pnty[3])/(diff2+!(diff2));
  if (diff0==0)
    {
      if (y1+dy+HMAN>=pnty[0])
	 hitflag=4;
    }
  else
    if ((int)((m2-0.05*speed)*100)<=(m1*100) &&
	     (m1*100)<=(int)((m2+0.05*speed)*100)) hitflag=4;
}

dorcheck()
{
int c,yy1,xx1;

  yy1=y1+HMAN;   /*+4*/
  /*find new door*/

/*  printf("%d",hitflag);   */
/*    printf("%d",doorflag);*/
  doorflag=0;

  for (c=0;c<NUMDOR;c++)
    {
    switch (hitflag)
      {
      case 1:     /*left door*/
	  if (((door[c].a[1]>door[c].a[3])&&(door[c].a[1]>=yy1&&yy1>=door[c].a[3]) ||
	   (door[c].a[1]<door[c].a[3])&&(door[c].a[1]<=yy1&&yy1<=door[c].a[3]))&&
	   ((door[c].a[0]>door[c].a[2])&&(door[c].a[0]+10>x1+dx&&x1+dx>door[c].a[2]-10)||
	   (door[c].a[0]<door[c].a[2])&&(door[c].a[0]-10<x1+dx&&x1+dx<door[c].a[2]+10)||
	   (door[c].a[0]==door[c].a[2])&&(x1+dx<=door[c].a[0])&&(door[c].a[0]<300)))
	     {
	     if (door[c].vis==0)
	       {
	       doorflag=1;
	       newloc=door[c].next;
	       c=NUMDOR;
	       }
	     }
	break;
      case 2:     /*top door*/
	 if (door[c].a[1]==0&&door[c].a[3]==0&&!doorflag) yy1=y1;
	 else yy1=yy1-8;
	 if (((door[c].a[0]>door[c].a[2])&&(door[c].a[0]>x1&&x1>door[c].a[2]) ||
	   (door[c].a[0]<door[c].a[2])&&(door[c].a[0]<x1&&x1<door[c].a[2]))&&
	   ((door[c].a[1]>door[c].a[3])&&(door[c].a[1]>=yy1&&yy1>=door[c].a[3])||
	   (door[c].a[1]<door[c].a[3])&&(yy1<=door[c].a[3]&&yy1>=door[c].a[1])||
	   (door[c].a[1]==door[c].a[3])&&(yy1-speed<=door[c].a[1])))  /*18*/
	   {
	   if (door[c].vis==0)
	     {
	     if (door[c].a[1]<150 && door[c].a[3]<150)
	       {
	       doorflag=4;
	       newloc=door[c].next;
	       if (curloc==57&&c==2) spec[23]=1;
	       if (curloc==58&&c==3) spec[23]=2;
	       if (curloc==62)
		 switch(c)
		   {
		   case 0:  spec[23]=3; break;
		   case 1:  spec[23]=4; break;
		   case 2:  spec[23]=5; break;
		   }
	       c=NUMDOR;
	       }
	     }
	   }
       break;
      case 3:     /*right door*/
	 if (((door[c].a[1]>door[c].a[3])&&(door[c].a[1]>=yy1&&yy1>=door[c].a[3]) ||
	   (door[c].a[1]<door[c].a[3])&&(door[c].a[1]<=yy1&&yy1<=door[c].a[3]))&&
	   ((door[c].a[0]>door[c].a[2])&&(door[c].a[0]+10>=x1+dx+WMAN&&x1+WMAN+dx>=door[c].a[2]-10)||
	   (door[c].a[0]<door[c].a[2])&&(door[c].a[0]-10<=x1+dx+WMAN&&x1+WMAN+dx<=door[c].a[2]+10)||
	   ((door[c].a[0]==door[c].a[2])&&(x1+dx+WMAN>door[c].a[0]-speed)&&(door[c].a[0]>300))))
	   {                                                      /*10*/
	   if (door[c].vis==0)
	     {
	     doorflag=3;
	     newloc=door[c].next;
	     c=NUMDOR;
	     }
	   }
       break;
      case 4:     /*bottom door*/
	 if (((door[c].a[0]>door[c].a[2])&&(door[c].a[0]>x1&&x1>door[c].a[2]) ||
	   (door[c].a[0]<door[c].a[2])&&(door[c].a[0]<x1&&x1<door[c].a[2]))&&
	   ((door[c].a[1]>door[c].a[3])&&(door[c].a[1]>=yy1&&yy1>=door[c].a[3])||
	   (door[c].a[1]<door[c].a[3])&&(door[c].a[1]<=yy1&&yy1<=door[c].a[3])||
	   (door[c].a[1]==door[c].a[3])&&(door[c].a[1]<=yy1+10)))
	   {
	   if (door[c].vis==0)
	     {
	     if (door[c].a[1]>150&&door[c].a[3]>150)
	       {
	       doorflag=2;
	       newloc=door[c].next;
	       c=NUMDOR;
	       }
	     }
	   }
       break;
       }	/*end switch*/
    }          /*end for*/
}

dorhit()
{
int c,xx1,flag;

  /*find new door*/
/* printf("\n%d",doorflag);*/
  for (c=0;c<NUMDOR;c++)
    {
    if (newloc==42) {x1=40; x3=20; /*c=NUMDOR;*/}
    if (newloc==43) {x1=619; x3=639;/*  c=NUMDOR;*/}
    switch (doorflag)
      {
      case 1:     /*left door-right door*/
	   if (door[c].vis==0)
	     {
	       if (door[c].a[0]>300&&door[c].a[2]>300)
		 {
		 if (abs(door[c].a[1]-door[c].a[3])<80)
		   y1=(int)(door[c].a[1]+(door[c].a[3]-door[c].a[1])/2)-HMAN;
		 if (door[c].a[0]>door[c].a[2])
		   x1=door[c].a[2];
		 else
		   x1=door[c].a[0];
		 x1=x1-15-speed;
		 if (spec[20]==2) {x3=x1; x1-=20; mode3=1;}
		 c=NUMDOR;
		 }
	       }
	break;
      case 2:     /*bottom door-top door*/
	   if (door[c].vis==0)
	     {
	       if (door[c].a[1]==door[c].a[3] && door[c].a[1]<150)
		 {
		 if (curloc<8)
		   x1=(int)(door[c].a[0]+(door[c].a[2]-door[c].a[0])/2);
		 if (door[c].a[1]<=door[c].a[3])
		   y1=door[c].a[3]-HMAN;
		 else
		   y1=door[c].a[1]-HMAN;
		 y1=y1+speed;
/*                 if (curloc>23&&curloc<54&&curloc!=41) y1=y1+HMAN+5;*/
                 if (curloc>23&&curloc<54&&curloc==41) y1=y1-HMAN/2-20;
                 if (curloc>23&&curloc<54) y1=y1+HMAN+5;
      		 c=NUMDOR;
		 if (curloc==58&&newloc==57) x1=495;
		 if (curloc==59&&newloc==57) x1=165;
		 if (spec[20]==2) 
			{if (newloc==41) {y3=y1; y1+=5; mode3=0;}  /*special mom location*/
			 else  {y3=y1; y1+=20; mode3=0;}}
		 if (newloc==41) y1=y1-15-speed;
		 }
	     }
       break;
      case 3:     /*right door-left door*/
	     if (door[c].vis==0)
	       {
		 if (door[c].a[0]<300&&door[c].a[2]<300)
		   {
		   if (abs(door[c].a[1]-door[c].a[3])<80)
		     y1=(int)(door[c].a[3]+(door[c].a[1]-door[c].a[3])/2)-HMAN;
		   if (door[c].a[0]>door[c].a[2])
		     x1=door[c].a[0];
		   else
		     x1=door[c].a[2];
		   x1=x1+7+speed;
		   if (spec[20]==2) {x1+=20; x3=x1-20; mode3=4;}
		   c=NUMDOR;
		   }
		 }
       break;
      case 4:     /*top door-bottom door*/
	   if (door[c].vis==0)
	     {
	       if ((door[c].a[3]==door[c].a[1])&&(door[c].a[1]>150))
		 {
		 if (door[c].a[1]>=door[c].a[3])
		   y1=door[c].a[3]-HMAN;
		 else
		   y1=door[c].a[1]-HMAN;
		 y1=y1-speed-5;  /*-5*/
		 if (spec[20]==2)  {y3=y1;y1-=20;  mode3=2;}

		 c=NUMDOR;
		 }
	       }
       break;
       }	/*end switch*/
    }          /*end for*/
}

mobhit()       /*check for hit with objects*/
{
int nx,ny,ny2,a;

nx=x1+WMAN;
ny=y1+HMAN;
ny2=y1+20;

for (a=0;a<NUMCAR;a++)
  {
  if  (((((mobj[a].p[0]<=nx) && (nx<= (mobj[a].p[0]+mobj[a].p[2]))) ||
       ((mobj[a].p[0]<=x1) && (x1<=(mobj[a].p[0]+mobj[a].p[2]))))  &&
      (((mobj[a].p[1]<=ny) && (ny<= (mobj[a].p[1]+mobj[a].p[3]))) ||
      ((mobj[a].p[1]<=y1) && (y1<= (mobj[a].p[1]+mobj[a].p[3])))||
      ((mobj[a].p[1]<=ny2) && (ny2<= (mobj[a].p[1]+mobj[a].p[3])))))
       && (mobj[a].loc==curloc))
    {
    hitflag=6;
    a=NUMCAR;
    }
  }
}

obhit()       /*check for hit with objects*/
{
int nx,ny,a;

nx=x1+dx+WMAN;
ny=y1+dy+HMAN;
for (a=0;a<NUMOBJ;a++)
  {
  if ((obj[a].p[0]<=nx) && (nx<= (obj[a].p[0]+obj[a].p[2]+WMAN)) &&
      (obj[a].p[1]<=ny) && (ny<= (obj[a].p[1]+obj[a].p[3])) &&
      (obj[a].loc==curloc) && (a<28 || a>118))
    {
    hitflag=5;
    a=NUMOBJ;
    }
  }
}

load_events(struct event eve[NUMEVE])
{
int a;
FILE *fptr;
char nm[256];

a=0;
getcwd(PATH,512);
strcat(PATH,LPATH);

strcpy(nm,PATH);
strcat(nm,"EVENT.BIN");
if ( (fptr=fopen(nm,"rb"))==NULL)
   {printf("Can't open file %s",nm); getch(); }
else
   {
   for (a=0;a<NUMEVE;a++)
     fread(&eve[a],sizeof(eve[0]),1,fptr);
   }
fclose(fptr);
}    			/*end load events*/

make_words()		/*function to separate sentence into words*/
{
int len,a;
int flag1;           /*0-nothing 1-letters */

wdflag=0;
flag1=0;
len=strlen(it);
strcpy(cword[0].nm,"");
a=0;
while(a<len)
  {              /*if we have a letter-symbol  ! ? . ,*/
  if (it[a]!=32&&flag1<2&&
      ((it[a]!=33&&it[a]!=34&&it[a]!=39&&it[a]!=63&&
      it[a]!=46&&it[a]!=44)||spec[3]==0))
    {
    flag1=1;
    if (strlen(cword[wdflag].nm)<15)
      strncat(cword[wdflag].nm,&it[a],1);     /*&it[a]*/
    else a=len;
    }
  else
    if (it[a]!=32&&flag1==2&&
	((it[a]!=33&&it[a]!=34&&it[a]!=39&&it[a]!=63&&
	it[a]!=46&&it[a]!=44)||spec[3]==0))
      { 			/*we have a new word*/
      wdflag++;
      strcpy(cword[wdflag].nm,"");
      strncat(cword[wdflag].nm,&it[a],1);  /*&it*/
      flag1=0;
      if (a>0)
      {
      if (it[a-1]==32 && it[a+1]==32)
	{
	flag1=3;
	a--;
	}
      }
    else             /*a==0*/
      {
      if (it[a+1]==32 && a==0)
	{
	flag1=3;
	a--;
	}
      }
      }
    else
      if (it[a]==32)    /*space bar*/
	{
	if (flag1!=0)   /*space(s) before 1st word*/
	  flag1=2;    /*new word- the end of the old word*/
	}
   a++;
   }   /*end while*/
it[0]=0;
}	/*end make words*/

refresh()
{
redraw=1;
onemo=1;
ex=1;
}

shower()
{
     /*take a shower*/
if (curloc==4)  /*in bathroom*/
  if (close_enough(22))
     { obj[21].loc=4; retsen=5; spec[1]=1;}
  else
      retsen=6;   /*not close enough*/
else
  retsen=25;   /*no tv here*/
}

draw_cursor()
{
setcolor(15);
setactivepage(page);
outtextxy(cursx,cursy,cursor);
setactivepage(!page);
outtextxy(cursx,cursy,cursor);
}

start_over()		/*start game over*/
{
int a;

dx=dy=0;     doorflag=0;   refresh();
brush=0;  cur=0;
lcolor=0;  newloc=1;   curobj=-1;  onepic=0;  telpic=90;
mtime.ti_hour=6/*9*/;  mtime.ti_min=0;  mtime.ti_sec=0; mtime.ti_hund=0;
moonindx=0;

init_var();
init_var2();
/*restore objects status*/
load_obj();
load_mobj();          /*load moving objects*/
init_mob();
init_ob();

}

init_var()		/*initialize variables*/
{
int a;

x1=280;       /*set current coord*/
y1=200;
x2=x1;  y2=y1;
x3=361;  y3=222;
x4=x3;  y4=y3;
moonindx=0; shipindx=0;
ampm=0; page=0;
mode=3;    mode3=3;
numimg=6;  numimg3=6;
slot=0/*6*/;  channel=0;
for(a=0;a<10;a++)
   sent[a]=-1;
for(a=0;a<=NUMSPEC;a++)
   spec[a]=0;
cash=0; cash0=0;
del=3000;   /*del=320;*/  /*  del=20 for 386*/
inv=2;
cursx=16;  cursy=310;   precur=16;
}

init_var2()
{
x1=280;       /*set current coord*/
y1=200; x2=x1;  y2=y1; x3=361;  y3=222; x4=x3;  y4=y3; ampm=0; page=0;
mode=3;   mode3=3; numimg=6;  numimg3=6; curloc=1;  curloc3=5; newloc=1;
}

init_mob()
{
int a;

for (a=0;a<NUMCAR;a++)
  {
  /*set initial car positions*/
  if (a<15)
    {
    mobj[a].p[0]=500;
    mobj[a].p[1]=155;
    }
  else
    {
    mobj[a].p[0]=4;
    mobj[a].p[1]=225;
    }
  carx[a]=mobj[a].p[0];
  }
for (a=NUMCAR;a<NUMCAR+NUMROAD;a++)
  {
  mobj[a].p[0]=80+160*(a-NUMCAR);
  mobj[a].p[1]=185;
  roadx[a-NUMCAR]=mobj[a].p[0];
  }
for (a=NUMCAR+NUMROAD;a<NUMCAR+NUMROAD+NUMSPIKE;a++)
  {
  mobj[a].p[0]=80+160*(a-NUMCAR-NUMROAD);
  mobj[a].p[1]=56;
  spikex[a-NUMCAR-NUMROAD]=mobj[a].p[0];
  }
}

init_ob()
{
int a,aa;

for (a=119;a<131;a++)
  {
  /*set initial car positions*/
  if (a==119 || a==123 || a==127) aa=0;
  if (a==120 || a==124 || a==128) aa=1;
  if (a==121 || a==125 || a==129) aa=2;
  if (a==122 || a==126 || a==130) aa=3;
  obj[a].p[0]= aa*150 + 25;
  obj[a].p[1]=190;
  }
obj[131].p[0]= 500;  obj[131].p[1]=250;
obj[132].p[0]= 220;  obj[132].p[1]=10;
obj[133].p[0]= 10;  obj[133].p[1]=210;
obj[134].p[0]= 110;  obj[134].p[1]=160;
obj[135].p[0]= 52;  obj[135].p[1]=65;
obj[136].p[0]= 475;  obj[136].p[1]=265;
obj[137].p[0]= 600;  obj[137].p[1]=126;
obj[138].p[0]= 432;  obj[138].p[1]=126;
obj[139].p[0]= 532;  obj[139].p[1]=82;
obj[140].p[0]= 10;  obj[140].p[1]=220;
}

dead()
{
qflg=1;
putout("Play Again? (Y/N)");
}

save_game()
{
savmenu();
}

restore_game()
{
moonindx=0;
resmenu();
}

dir_char()
{
      if (dx!=0||dy!=0)
	{
	if (c2>=(10-speed)) c2=-(10-speed);
	else
	  c2++;
	}
      switch(mode)
       {
       case 0: 			/*down*/
	 numimg2=(c2<0)*6 + (c2>=0)*7;
	 break;
       case 1:                   /*left*/
	 numimg2=(c2>=0);
	 break;
       case 2:                   /*up*/
	 numimg2=(c2<0)*2 + (c2>=0)*3;
	 break;
       case 3:                  /*stopped*/
	 numimg2=numimg;
	 break;
	case 4:
	  numimg2=(c2<0)*4 + (c2>=0)*5;   /*right*/
	  break;
       } 	/*end switch*/
    numimg=numimg2;		/*set new image number*/
    x2=x1;  y2=y1;   /*save old coord*/
}

dir_bot()
{
      if (dx2!=0||dy2!=0)
	{
	if (c3>=(10-speed)) c3=-(10-speed);
	else
	  c3++;
	}
      switch(mode3)
       {
       case 0: 			/*down*/
	 numimg4=(c3<0)*6 + (c3>=0)*7;
	 break;
       case 1:                   /*left*/
	 numimg4=(c3>=0);
	 break;
       case 2:                   /*up*/
	 numimg4=(c3<0)*2 + (c3>=0)*3;
	 break;
       case 3:                  /*stopped*/
	 numimg4=numimg3;
	 break;
	case 4:
	  numimg4=(c3<0)*4 + (c3>=0)*5;   /*right*/
	  break;
       } 	/*end switch*/
    numimg3=numimg4;		/*set new image number*/
    x4=x3;  y4=y3;   /*save old coord*/
}

mvbot()
{
dx2=0;  dy2=0;

if (spec[20]==2)
{
if (abs(abs(x1)-abs(x3))>20)
  {
  if (x1<x3) {dx2=-speed; mode3=1;}
  else {dx2=speed; mode3=4;}
  }
if (abs(abs(y1)-abs(y3))>20)
  {
  if (y1<y3) {dy2=-speed; mode3=2;}
  else {dy2=speed; mode3=0;}
  }
}
}

one()
{
      setactivepage(!page);
      if (curloc==42||curloc==43)
	{
	erase_road();
	erase_spike();
	}
      erase_char();
      if (spec[20]>=1&&curloc3==curloc)
	erase_bot();
      if (spec[4]==1)
	{
	erase_mob();   /*erase moving objects*/
	/*getmob();*/  /*get background screens for moving objects*/
	}
      setactivepage(page);
}
